Public Class WebForm1
    Inherits System.Web.UI.Page

#Region " Web Form Designer Generated Code "

    'This call is required by the Web Form Designer.
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()

    End Sub
    Protected WithEvents btnSingleAddressCheck As System.Web.UI.WebControls.Button
    Protected WithEvents Label4 As System.Web.UI.WebControls.Label
    Protected WithEvents txtCustomerID As System.Web.UI.WebControls.TextBox
    Protected WithEvents Label5 As System.Web.UI.WebControls.Label
    Protected WithEvents txtCity As System.Web.UI.WebControls.TextBox
    Protected WithEvents Label3 As System.Web.UI.WebControls.Label
    Protected WithEvents txtState As System.Web.UI.WebControls.TextBox
    Protected WithEvents Label6 As System.Web.UI.WebControls.Label
    Protected WithEvents Label7 As System.Web.UI.WebControls.Label
    Protected WithEvents txtZip5 As System.Web.UI.WebControls.TextBox
    Protected WithEvents txtCountry As System.Web.UI.WebControls.TextBox
    Protected WithEvents Label8 As System.Web.UI.WebControls.Label
    Protected WithEvents txtResults As System.Web.UI.WebControls.TextBox
    Protected WithEvents Label1 As System.Web.UI.WebControls.Label
    Protected WithEvents Label10 As System.Web.UI.WebControls.Label
    Protected WithEvents Label11 As System.Web.UI.WebControls.Label
    Protected WithEvents txtAddress As System.Web.UI.WebControls.TextBox
    Protected WithEvents txtCityAbbreviation As System.Web.UI.WebControls.TextBox
    Protected WithEvents txtCounty As System.Web.UI.WebControls.TextBox
    Protected WithEvents lblCounty As System.Web.UI.WebControls.Label
    Protected WithEvents lblCityAbbreviation As System.Web.UI.WebControls.Label
    Protected WithEvents txtPlus4 As System.Web.UI.WebControls.TextBox
    Protected WithEvents txtAddress2 As System.Web.UI.WebControls.TextBox
    Protected WithEvents Label2 As System.Web.UI.WebControls.Label

    'NOTE: The following placeholder declaration is required by the Web Form Designer.
    'Do not delete or move it.
    Private designerPlaceholderDeclaration As System.Object

    Private Sub Page_Init(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Init
        'CODEGEN: This method call is required by the Web Form Designer
        'Do not modify it using the code editor.
        InitializeComponent()
    End Sub

#End Region

    'Melissa Data Single Address Check
    'Intructions
    '=============================================================
    '1) Add a Web Reference:
    'Production server:
    'http://ws.melissadata.com/dqws/Address.asmx
    'Name it: dqws

    Private Sub Page_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

    End Sub

    Private Sub btnSingleAddressCheck_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSingleAddressCheck.Click
        'initialize variables
        'temporary string
        Dim tStr1 As String
        'Service Faults counter
        Dim ServiceFaultsCount As String
        'a reference string to be passed with the request and 
        'received back with the response
        Dim _transmission_reference As String

        'Zip5 code
        Dim Zip5 As String
        'Plus4 code
        Dim Plus4 As String

        '3) Initialize it:
        '==================================================
        'create action object
        Dim Action As _
            New dqws.mdWebServices
        'create request object
        Dim Request As _
            New dqws.RequestRecord
        'create response object
        Dim Response As _
            New dqws.ResponseRecord

        '4) enter the CustomerID here
        Request.CustomerID = txtCustomerID.Text

        '5)Choose a package. For example:
        'when calling doSingleRecord action set pkgMultipleRecords=false
        Request.pkgMultipleRecords = False

        Request.pkgAddressMailing = True
        'Request.pkgAddressGeoCode = True

        '6) Initalize address variables. For example:

        'Melissa Data Corp
        '22382 Avenida(Empresa)
        'Rancho Santa Margarita, CA 92688-2112
        'Phone: 949-589-5200

        'get the zip code for this address
        Request.City = txtCity.Text
        Request.Address = txtAddress.Text
        Request.Address2 = txtAddress2.Text
        Request.State = txtState.Text
        Request.Zip5 = txtZip5.Text
        Request.Plus4 = txtPlus4.Text
        Request.Country = txtCountry.Text

        '6) call the web service.
        ' Note: make a loop structure in order to prevent
        ' loss of data in case of bad connection to dqws.
        '=============================================================
        Dim Retry As Integer
        Dim ReqRet As Boolean

        Retry = 0
        ReqRet = False

        Do While ((Not ReqRet) And (Retry < 5))
            Try
                Response = Action.doSingleRecord(Request)
                ReqRet = True
            Catch ReqEx As Exception
                Retry = Retry + 1
            End Try
        Loop

        'get response parameters
        '=============================================================
        If Not (Response Is Nothing) Then
            ' check if there are a Service Faults
            If Not (Response.ServiceFaults Is Nothing) Then
                ServiceFaultsCount = Response.ServiceFaults.count
                ' count the Service Faults
                If Response.ServiceFaults.count > 0 Then
                    ' if there are service faults, show the first one
                    tStr1 = tStr1 & "ServiceFaults.Fault(0).Code=" & Response.ServiceFaults.Fault(0).Code & vbCrLf
                    tStr1 = tStr1 & "ServiceFaults.Fault(0).Desc=" & Response.ServiceFaults.Fault(0).Desc & vbCrLf
                    tStr1 = tStr1 & "ServiceFaults.Fault(0).Detail=" & Response.ServiceFaults.Fault(0).Detail & vbCrLf
                    tStr1 = tStr1 & "ServiceFaults.Fault(0).Source=" & Response.ServiceFaults.Fault(0).Source & vbCrLf
                End If
            End If

            ' check if there are a Service Results
            If Not (Response.ServiceResult Is Nothing) Then
                ' if there are a Service Results show them
                If Not (Response.ServiceResult.ErrorCode Is Nothing) Then
                    tStr1 = tStr1 & "ServiceResult.ErrorCode=" & Response.ServiceResult.ErrorCode & vbCrLf
                End If

                If Not (Response.ServiceResult.ErrorDesc Is Nothing) Then
                    tStr1 = tStr1 & "ServiceResult.ErrorDesc=" & Response.ServiceResult.ErrorDesc & vbCrLf
                End If

                If Not (Response.ServiceResult.StatusCode Is Nothing) Then
                    tStr1 = tStr1 & "ServiceResult.StatusCode=" & Response.ServiceResult.StatusCode & vbCrLf
                End If

                If Not (Response.ServiceResult.StatusDesc Is Nothing) Then
                    tStr1 = tStr1 & "ServiceResult.StatusDesc=" & Response.ServiceResult.StatusDesc & vbCrLf
                End If
            End If

            'BEGIN AddressResult
            If Not (Response.Address Is Nothing) Then
                If Not (Response.Address.Result Is Nothing) Then
                    Dim i As Integer
                    Dim i1 As Integer

                    ' show the errors and status
                    tStr1 = tStr1 & vbCrLf
                    tStr1 = tStr1 & "Record(" & i + 1 & ")=" & "AddressResult.ErrorCode=" & Response.Address.Result.ErrorCode & vbCrLf
                    tStr1 = tStr1 & "Record(" & i + 1 & ")=" & "AddressResult.ErrorDesc=" & Response.Address.Result.ErrorDesc & vbCrLf
                    tStr1 = tStr1 & "Record(" & i + 1 & ")=" & "AddressResult.StatusCode=" & Response.Address.Result.StatusCode & vbCrLf
                    tStr1 = tStr1 & "Record(" & i + 1 & ")=" & "AddressResult.StatusDesc=" & Response.Address.Result.StatusDesc & vbCrLf
                    tStr1 = tStr1 & vbCrLf

                    'check AddressFaults
                    If Response.Address.Faults.count = 0 Then
                        'no PhysicalAddressFaults

                        'check if object exist
                        If Not (Response.Address.Urbanization Is Nothing) Then
                            tStr1 = tStr1 & "Record(" & i + 1 & ")=" & "Address.Urbanization.UrbanizationCode=" & Response.Address.Urbanization.Code & vbCrLf
                        End If
                        If Not (Response.Address.Street Is Nothing) Then
                            tStr1 = tStr1 & "Record(" & i + 1 & ")=" & "Address.Street.Address=" & Response.Address.Street & vbCrLf
                            txtAddress.Text = Response.Address.Street
                        End If
                        If Not (Response.Address.Street2 Is Nothing) Then
                            tStr1 = tStr1 & "Record(" & i + 1 & ")=" & "Address.Street.Address2=" & Response.Address.Street2 & vbCrLf
                            txtAddress2.Text = Response.Address.Street2
                        End If
                        If Not (Response.Address.City Is Nothing) Then
                            tStr1 = tStr1 & "Record(" & i + 1 & ")=" & "Address.City.CityName=" & Response.Address.City.Name & vbCrLf
                            tStr1 = tStr1 & "Record(" & i + 1 & ")=" & "Address.City.CityAbbreviation=" & Response.Address.City.Abbreviation & vbCrLf
                            txtCity.Text = Response.Address.City.Name
                            lblCityAbbreviation.Visible = True
                            txtCityAbbreviation.Visible = True
                            txtCityAbbreviation.Text = Response.Address.City.Abbreviation
                        End If
                        If Not (Response.Address.State Is Nothing) Then
                            tStr1 = tStr1 & "Record(" & i + 1 & ")=" & "Address.State.StateAbbreviation=" & Response.Address.State.Abbreviation & vbCrLf
                            txtState.Text = Response.Address.State.Abbreviation
                        End If
                        If Not (Response.Address.Zip Is Nothing) Then
                            tStr1 = tStr1 & "Record(" & i + 1 & ")=" & "Address.Zip.Zip5=" & Response.Address.Zip.Zip5 & vbCrLf
                            tStr1 = tStr1 & "Record(" & i + 1 & ")=" & "Address.Zip.Plus4=" & Response.Address.Zip.Plus4 & vbCrLf
                            txtZip5.Text = Response.Address.Zip.Zip5
                            txtPlus4.Text = Response.Address.Zip.Plus4
                        End If

                        If Not (Response.Address.County Is Nothing) Then
                            tStr1 = tStr1 & "Record(" & i + 1 & ")=" & "Address.County.CountyName=" & Response.Address.County.Name & vbCrLf
                            lblCounty.Visible = True
                            txtCounty.Visible = True
                            txtCounty.Text = Response.Address.County.Name
                        End If
                        tStr1 = tStr1 & vbCrLf

                        If Not (Response.Address.GeoCode Is Nothing) Then
                            tStr1 = tStr1 & "Record(" & i + 1 & ")=" & "Response.Address.GeoCode.Latitude=" & Response.Address.GeoCode.Latitude & vbCrLf
                            tStr1 = tStr1 & "Record(" & i + 1 & ")=" & "Response.Address.GeoCode.Longitude=" & Response.Address.GeoCode.Longitude & vbCrLf
                        End If
                        tStr1 = tStr1 & vbCrLf

                    Else
                        'show AddressFaults
                        tStr1 = tStr1 & "Record(" & i + 1 & ")=" & "Address.AddressFaults.count=" & Response.Address.Faults.count & vbCrLf
                        For i1 = 0 To (Response.Address.Faults.count - 1)
                            tStr1 = tStr1 & "Record(" & i + 1 & ")=" & "AddressFaults.Fault(" & i1 & ").Code=" & Response.Address.Faults.Fault(i1).Code & vbCrLf
                            tStr1 = tStr1 & "Record(" & i + 1 & ")=" & "AddressFaults.Fault(" & i1 & ").Desc=" & Response.Address.Faults.Fault(i1).Desc & vbCrLf
                            tStr1 = tStr1 & "Record(" & i + 1 & ")=" & "AddressFaults.Fault(" & i1 & ").Detail=" & Response.Address.Faults.Fault(i1).Detail & vbCrLf
                            tStr1 = tStr1 & "Record(" & i + 1 & ")=" & "AddressFaults.Fault(" & i1 & ").Source=" & Response.Address.Faults.Fault(i1).Source & vbCrLf
                            tStr1 = tStr1 & vbCrLf

                        Next
                    End If
                End If
            End If
            'END AddressResult
        End If

        txtResults.Text = tStr1
    End Sub
End Class
